{% extends 'base.html' %}

{% block content %}
  <script src="https://cdn.jsdelivr.net/npm/chart.js@^4"></script>
  <script src="https://cdn.jsdelivr.net/npm/axios@1"></script>

  <p class="h1">{% block title %} Train reliability this week {% endblock %}</p>

  <div class="row">
    <div class="col">
      <div class="input-group">
        <form action="{{ url_for('index')}}" method="get" id="form1">
          <div class="form-group">
            {% for station in stations %}
            <input type="radio" id="{{ station }}" name="stationid" value={{ station }} {{ 'checked' if station_id==station else '' }}>
            <label for="{{ station }}">{{ stations[station] }}</label><br>
            {% endfor %}
          </div>
        </form>
      </div>
    </div>
  </div>
  <div class="vr"></div>
  <div class="row">
    <div class="col col-sm">
      <div class="row" style="height: 280px">
        <canvas id="accuracyChart"></canvas>
      </div>
      <div class="row">
        <p class="text-center" id="totalInfo">Total trains</p>
      </div>
    </div>
    <div class="col col-sm">
      <div class="row">
        <p class="text-center fs-1 fw-bold" id="accuracy">0%</p>
      </div>
      <div class="row">
        <p class="text-center fs-6 fw-light lh-sm">Excluding minor delays</p>
      </div>
      <div class="row">
        <p class="text-center fs-1" id="accuracyWithMinor">0%</p>
      </div>
      <div class="row">
        <p class="text-center fs-6 fw-light lh-sm">All trains including minor delays</p>
      </div>
    </div>
  </div>
  <div class="row">
    <div class="col">
      <div class="row">
        <p class="text-center fs-2 lh-sm">Minor delays</p>
      </div>
      <div class="row">
        <p class="text-center lh-sm">Minor delays are {{ minor_delay }} minutes or less.</p>
      </div>
      <div class="row">
        <p class="text-center" id="delaysInfo">Average delay excluding minor</p>
      </div>
    </div>
    <div class="col">
      <div class="row">
        <p class="text-center fs-2">Major delays</p>
      </div>
      <div class="row">
        <p class="text-center lh-sm">Major delays are {{ major_delay }} minutes or more.</p>
      </div>
      <div class="row">
        <p class="text-center lh-sm" id="majorInfo">Major delay average</p>
      </div>
    </div>
  </div>
  <div class="row">
    <a href="https://www.nationalrail.co.uk/live-trains/departures/{{station_id}}/">Live departures board</a>
  </div>
  <div class="row">
    <table class="table" id="livedeparturestable">
      <thead>
        <tr>
          <th scope="col">Scheduled</th>
          <th scope="col">Destination</th>
          <th scope="col">Expected</th>
          <th scope="col">Operator</th>
        </tr>
      </thead>
      <tbody>
      </tbody>
    </table>
  </div>

<script>
    var accuracyConfig = {
      type: 'pie',
      data: {

        labels: ["On time", "Minor delays", "Delayed", "Major delays", "Cancelled"],
        datasets: [{
          data: [0,0,0,0,0],
          backgroundColor: ["#90EE90", "#CAFFBF", "#FCFFB6", "#FFD6A5", "#FFADAD"]
        }]
      },
      options: {
        responsive: true,
        maintainAspectRatio: false,
        plugins: {
          legend: {
            display: true
          }
        }
      }
    }

    document.getElementById("form1").onchange = function() { 
      document.getElementById("form1").submit(); 
    }

    function getFilters() {
      const urlParams = new URLSearchParams(window.location.search)
      let joinChar = '?'
      let filters = ""
      if (urlParams.has('stationid')) {
        filters = joinChar + 'stationid=' + urlParams.get('stationid')
        joinChar = "&"
      }
      return filters
    }

    function formatMinutes(duration) {
      //Duration is in minutes 4.333
      if (duration == 0) {
        return "No"
      }
      return duration.toFixed(1) + "mins average"
    }

    function getData() {
      getStats()
      getBoard()
    }
    
    function getStats() {
      const accuracyCtx = document.getElementById('accuracyChart');
      window.accuracyChart = new Chart(accuracyCtx, accuracyConfig);

      let filters = getFilters()

      const start_generation = performance.now();
      axios.get(`/api/current${filters}`)
      .then(function (response) {
        accuracyConfig.data.datasets[0].data = response.data.metrics.plots
        window.accuracyChart.update()

        if ('totals' in response.data.metrics) {
          document.getElementById("totalInfo").innerText = response.data.metrics.totals.total + " trains in total"
          document.getElementById("delaysInfo").innerText = formatMinutes(response.data.metrics.delays.without_minor.average_delay) + " delay excluding minor"
          document.getElementById("majorInfo").innerText = formatMinutes(response.data.metrics.delays.major.average_delay) + " delay for major delays"

          document.getElementById("accuracy").innerText = response.data.metrics.accuracy.without_minor.toFixed(1) + "%"
          document.getElementById("accuracyWithMinor").innerText = response.data.metrics.accuracy.all.toFixed(1) + "%"
        }
      })
      .catch(function (error) {
          console.error("Error retrieving statistics");
          console.error(error);
      })
      .finally(function () {
        console.log(`Took ${((performance.now() - start_generation)/1000).toFixed(2)} seconds to get statistics`);
      })
    }

    function getBoard() {
      let filters = getFilters()

      const start_generation = performance.now();
      axios.get(`/api/station${filters}`)
      .then(function (response) {
        const departure_table = document.getElementById('livedeparturestable');
        for (let service of response.data.services) {
          let row = departure_table.insertRow();
          let scheduled_cell = row.insertCell();
          let scheduled_text = document.createTextNode(service.scheduled);
          scheduled_cell.appendChild(scheduled_text);
          let destination_cell = row.insertCell();
          let destination_text = document.createTextNode(service.destination);
          destination_cell.appendChild(destination_text);
          let expected_cell = row.insertCell();
          let expected_text = document.createTextNode(service.estimated);
          expected_cell.appendChild(expected_text);
          let operator_cell = row.insertCell();
          let operator_text = document.createTextNode(service.operator);
          operator_cell.appendChild(operator_text);
        }
      })
      .catch(function (error) {
          console.error("Error retrieving live departures");
          console.error(error);
      })
      .finally(function () {
        console.log(`Took ${((performance.now() - start_generation)/1000).toFixed(2)} seconds to get live departures`);
      })
    }

    if (window.location.hostname == "localhost") {
      axios.defaults.baseURL = window.location.origin;
    } else if (window.location.port == "") {
      axios.defaults.baseURL = window.location.origin + "/rail";
    } else {
      axios.defaults.baseURL = window.location.origin;
    }
    window.onload = getData()
</script> 

{% endblock %}
